(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('chokidar'), require('@babel/runtime/regenerator'), require('globby'), require('fs-extra'), require('naming-style'), require('js-beautify'), require('lodash.throttle')) :
  typeof define === 'function' && define.amd ? define(['exports', 'chokidar', '@babel/runtime/regenerator', 'globby', 'fs-extra', 'naming-style', 'js-beautify', 'lodash.throttle'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VueAutoRouter = {}, global.Chokidar, global._regeneratorRuntime, global.Globby, global.FsExtra, global.NamingStyle, global.JsBeautify, global.Throttle));
}(this, (function (exports, chokidar, _regeneratorRuntime, globby, fs, namingStyle, jsBeautify, throttle) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () {
              return e[k];
            }
          });
        }
      });
    }
    n['default'] = e;
    return Object.freeze(n);
  }

  var chokidar__namespace = /*#__PURE__*/_interopNamespace(chokidar);
  var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
  var globby__default = /*#__PURE__*/_interopDefaultLegacy(globby);
  var fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);
  var throttle__default = /*#__PURE__*/_interopDefaultLegacy(throttle);

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.

  // resolves . and .. elements in a path array with directory names there
  // must be no slashes, empty elements, or device names (c:\) in the array
  // (so also no leading and trailing slashes - it does not distinguish
  // relative and absolute paths)
  function normalizeArray(parts, allowAboveRoot) {
    // if the path tries to go above the root, `up` ends up > 0
    var up = 0;
    for (var i = parts.length - 1; i >= 0; i--) {
      var last = parts[i];
      if (last === '.') {
        parts.splice(i, 1);
      } else if (last === '..') {
        parts.splice(i, 1);
        up++;
      } else if (up) {
        parts.splice(i, 1);
        up--;
      }
    }

    // if the path is allowed to go above the root, restore leading ..s
    if (allowAboveRoot) {
      for (; up--; up) {
        parts.unshift('..');
      }
    }

    return parts;
  }

  // Split a filename into [root, dir, basename, ext], unix version
  // 'root' is just a slash, or nothing.
  var splitPathRe =
      /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  var splitPath = function(filename) {
    return splitPathRe.exec(filename).slice(1);
  };

  // path.resolve([from ...], to)
  // posix version
  function resolve() {
    var resolvedPath = '',
        resolvedAbsolute = false;

    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
      var path = (i >= 0) ? arguments[i] : '/';

      // Skip empty and invalid entries
      if (typeof path !== 'string') {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }

      resolvedPath = path + '/' + resolvedPath;
      resolvedAbsolute = path.charAt(0) === '/';
    }

    // At this point the path should be resolved to a full absolute path, but
    // handle relative paths to be safe (might happen when process.cwd() fails)

    // Normalize the path
    resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
      return !!p;
    }), !resolvedAbsolute).join('/');

    return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
  }
  // path.normalize(path)
  // posix version
  function normalize(path) {
    var isPathAbsolute = isAbsolute(path),
        trailingSlash = substr(path, -1) === '/';

    // Normalize the path
    path = normalizeArray(filter(path.split('/'), function(p) {
      return !!p;
    }), !isPathAbsolute).join('/');

    if (!path && !isPathAbsolute) {
      path = '.';
    }
    if (path && trailingSlash) {
      path += '/';
    }

    return (isPathAbsolute ? '/' : '') + path;
  }
  // posix version
  function isAbsolute(path) {
    return path.charAt(0) === '/';
  }

  // posix version
  function join() {
    var paths = Array.prototype.slice.call(arguments, 0);
    return normalize(filter(paths, function(p, index) {
      if (typeof p !== 'string') {
        throw new TypeError('Arguments to path.join must be strings');
      }
      return p;
    }).join('/'));
  }


  // path.relative(from, to)
  // posix version
  function relative(from, to) {
    from = resolve(from).substr(1);
    to = resolve(to).substr(1);

    function trim(arr) {
      var start = 0;
      for (; start < arr.length; start++) {
        if (arr[start] !== '') break;
      }

      var end = arr.length - 1;
      for (; end >= 0; end--) {
        if (arr[end] !== '') break;
      }

      if (start > end) return [];
      return arr.slice(start, end - start + 1);
    }

    var fromParts = trim(from.split('/'));
    var toParts = trim(to.split('/'));

    var length = Math.min(fromParts.length, toParts.length);
    var samePartsLength = length;
    for (var i = 0; i < length; i++) {
      if (fromParts[i] !== toParts[i]) {
        samePartsLength = i;
        break;
      }
    }

    var outputParts = [];
    for (var i = samePartsLength; i < fromParts.length; i++) {
      outputParts.push('..');
    }

    outputParts = outputParts.concat(toParts.slice(samePartsLength));

    return outputParts.join('/');
  }

  var sep = '/';
  var delimiter = ':';

  function dirname(path) {
    var result = splitPath(path),
        root = result[0],
        dir = result[1];

    if (!root && !dir) {
      // No dirname whatsoever
      return '.';
    }

    if (dir) {
      // It has a dirname, strip trailing slash
      dir = dir.substr(0, dir.length - 1);
    }

    return root + dir;
  }

  function basename(path, ext) {
    var f = splitPath(path)[2];
    // TODO: make this comparison case-insensitive on windows?
    if (ext && f.substr(-1 * ext.length) === ext) {
      f = f.substr(0, f.length - ext.length);
    }
    return f;
  }


  function extname(path) {
    return splitPath(path)[3];
  }
  var path = {
    extname: extname,
    basename: basename,
    dirname: dirname,
    sep: sep,
    delimiter: delimiter,
    relative: relative,
    join: join,
    isAbsolute: isAbsolute,
    normalize: normalize,
    resolve: resolve
  };
  function filter (xs, f) {
      if (xs.filter) return xs.filter(f);
      var res = [];
      for (var i = 0; i < xs.length; i++) {
          if (f(xs[i], i, xs)) res.push(xs[i]);
      }
      return res;
  }

  // String.prototype.substr - negative index don't work in IE8
  var substr = 'ab'.substr(-1) === 'b' ?
      function (str, start, len) { return str.substr(start, len) } :
      function (str, start, len) {
          if (start < 0) start = str.length + start;
          return str.substr(start, len);
      }
  ;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  var template = {
    parentNode: "\n{\n  path: '##path##',##redirect##\n  component: ##layoutComponent##, \n  children: [\n    {\n      path: '##customPath##',##redirect##\n      name: '##name##', \n      fullPath:'##fullPath##',\n      component: ##component##,\n      meta: ##meta##,\n    },\n    ##children##\n  ],\n}\n",
    leafNode: "\n{\n      path: '##path##',\n      component: ##layoutComponent##, \n      children: [\n        {\n          path: '##customPath##',##redirect##\n          name: '##name##', \n          fullPath:'##fullPath##',\n          component: ##component##,\n          meta: ##meta##,\n        },\n      ],\n}\n",
    singleParentNode: "\n{\n  path: '##path##',\n  component: ##layoutComponent##, \n  children: [\n    {\n      path: '##customPath##',##redirect##\n      name: '##name##', \n      fullPath:'##fullPath##',\n      component: ##component##,\n      meta: ##meta##,\n    },\n  ],\n}\n",
    parentWithEntryNode: "\n{\n  path: '##path##',\n  component: ##layoutComponent##, \n  children: [\n    {\n      path: '##customPath##',##redirect##\n      name: '##name##', \n      fullPath:'##fullPath##',\n      component: ##component##,\n      meta: ##meta##,\n    },\n    ##children##\n  ],\n}\n"
  };

  var indent_size = 2;
  var indent_char = " ";
  var indent_with_tabs = false;
  var editorconfig = false;
  var eol = "\n";
  var end_with_newline = false;
  var indent_level = 0;
  var preserve_newlines = true;
  var max_preserve_newlines = 10;
  var space_in_paren = false;
  var space_in_empty_paren = false;
  var jslint_happy = false;
  var space_after_anon_function = false;
  var space_after_named_function = false;
  var brace_style = "collapse";
  var unindent_chained_methods = false;
  var break_chained_methods = false;
  var keep_array_indentation = false;
  var unescape_strings = false;
  var wrap_line_length = 0;
  var e4x = false;
  var comma_first = false;
  var operator_position = "before-newline";
  var indent_empty_lines = false;
  var templating = [
  	"auto"
  ];
  var jsPrettyConfig = {
  	indent_size: indent_size,
  	indent_char: indent_char,
  	indent_with_tabs: indent_with_tabs,
  	editorconfig: editorconfig,
  	eol: eol,
  	end_with_newline: end_with_newline,
  	indent_level: indent_level,
  	preserve_newlines: preserve_newlines,
  	max_preserve_newlines: max_preserve_newlines,
  	space_in_paren: space_in_paren,
  	space_in_empty_paren: space_in_empty_paren,
  	jslint_happy: jslint_happy,
  	space_after_anon_function: space_after_anon_function,
  	space_after_named_function: space_after_named_function,
  	brace_style: brace_style,
  	unindent_chained_methods: unindent_chained_methods,
  	break_chained_methods: break_chained_methods,
  	keep_array_indentation: keep_array_indentation,
  	unescape_strings: unescape_strings,
  	wrap_line_length: wrap_line_length,
  	e4x: e4x,
  	comma_first: comma_first,
  	operator_position: operator_position,
  	indent_empty_lines: indent_empty_lines,
  	templating: templating
  };

  var defaultLayoutComponent = '@/components/main';
  var placeholders = {
    component: '##component##',
    layoutComponent: '##layoutComponent##',
    meta: '##meta##',
    children: '##children##',
    path: '##path##',
    customPath: '##customPath##',
    name: '##name##',
    fullPath: '##fullPath##',
    redirect: '##redirect##'
  };
  var pagesPath = 'src/pages';

  var replacePathSplitForCommon = function replacePathSplitForCommon(str) {
    return str.replace(/\\/g, '/');
  };

  var replacePathSplit$1 = function replacePathSplit(str) {
    return replacePathSplitForCommon(str).replace(/\//g, path.sep);
  };

  var componentTemplates = {
    emptyComponent: "\n{\n    render(createElement) {\n        return createElement('router-view')\n    }\n}\n  ",
    dynamicImportComponent: function dynamicImportComponent(filePath) {
      return "() => import('@/" + replacePathSplitForCommon(filePath) + "')";
    },
    defaultLayoutComponent: "() => import('" + defaultLayoutComponent + "')"
  };

  var getEmptyNode = function getEmptyNode(routePath) {
    return {
      asEntry: false,
      routePath: routePath,
      metaJSON: {},
      level: routePath.split('/').length,
      component: componentTemplates.emptyComponent
    };
  };

  function offsetParentMetaJSONInfo(nodes) {
    console.log('offset');
    var routeDic = {};
    var newNodes = [];
    nodes.forEach(function (node) {
      var pathNodes = node.routePath.split('/');
      if (pathNodes <= 1) return;

      var _loop = function _loop(i) {
        var subPath = pathNodes.slice(0, i).join('/');
        if (routeDic[subPath]) return {
          v: void 0
        };
        var findedNode = nodes.find(function (n) {
          return n.routePath === subPath;
        });

        if (!findedNode) {
          findedNode = getEmptyNode(subPath);
          newNodes.push(findedNode);
        }

        routeDic[subPath] = findedNode;
      };

      for (var i = 1; i < pathNodes.length; i++) {
        var _ret = _loop(i);

        if (typeof _ret === "object") return _ret.v;
      }
    });
    nodes.splice.apply(nodes, [nodes.length, 0].concat(newNodes));
  }

  function getMetaInfos(_x) {
    return _getMetaInfos.apply(this, arguments);
  }

  function _getMetaInfos() {
    _getMetaInfos = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee3(cwd) {
      var dic, list, maxLevel, metaInfos, promises;
      return _regeneratorRuntime__default['default'].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              dic = {};
              list = [];
              maxLevel = 0;
              _context3.next = 5;
              return globby__default['default']([replacePathSplitForCommon(path.join(pagesPath, "**/meta.json"))], {
                cwd: cwd
              });

            case 5:
              metaInfos = _context3.sent;
              promises = metaInfos.map( /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee2(n) {
                  var asEntry, entryFilePath, filePath, tempPath, routePath, level, metaJSONPath, metaJSON, component;
                  return _regeneratorRuntime__default['default'].wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          n = replacePathSplit$1(n);
                          asEntry = false;
                          entryFilePath = replacePathSplit$1(path.join(cwd, path.dirname(n), 'index.vue'));
                          _context2.next = 5;
                          return fs__default['default'].pathExists(entryFilePath);

                        case 5:
                          asEntry = _context2.sent;
                          filePath = replacePathSplit$1(path.dirname(n)).replace(/^src(\/|\\)/, '');
                          tempPath = replacePathSplit$1(path.relative(pagesPath, n));
                          tempPath = replacePathSplitForCommon(path.dirname(tempPath));
                          routePath = tempPath === '.' ? '/' : tempPath.split('/').map(function (m) {
                            return namingStyle.hyphen(m);
                          }).join('/');
                          level = routePath.length == 1 ? 1 : routePath.split('/').length;

                          if (level > maxLevel) {
                            maxLevel = level;
                          }

                          metaJSONPath = path.resolve(cwd, n);
                          _context2.next = 15;
                          return fs__default['default'].readJSON(metaJSONPath);

                        case 15:
                          metaJSON = _context2.sent;
                          component = componentTemplates.dynamicImportComponent(filePath);

                          if (!asEntry) {
                            component = componentTemplates.emptyComponent;
                          }

                          dic[routePath] = {
                            asEntry: asEntry,
                            filePath: filePath,
                            routePath: routePath,
                            metaJSON: metaJSON,
                            level: level,
                            component: component
                          };
                          list.push(dic[routePath]);

                        case 20:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function (_x4) {
                  return _ref3.apply(this, arguments);
                };
              }());
              _context3.next = 9;
              return Promise.all(promises);

            case 9:
              list.forEach(function (n) {
                if (n.metaJSON.index === undefined) {
                  n.metaJSON.index = 99;
                }
              });
              list.sort(function (a, b) {
                return a.metaJSON.index - b.metaJSON.index;
              });
              list.forEach(function (n) {
                return delete n.metaJSON.index;
              });
              offsetParentMetaJSONInfo(list);
              console.log(list);
              return _context3.abrupt("return", {
                list: list,
                maxLevel: maxLevel
              });

            case 15:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return _getMetaInfos.apply(this, arguments);
  }

  function makeTree(data, level, prefix) {
    if (level === void 0) {
      level = 1;
    }

    if (prefix === void 0) {
      prefix = '';
    }

    var roots = data.filter(function (n) {
      return n.level === level && n.metaJSON.hidden !== true && n.routePath.indexOf(prefix) === 0;
    });
    var others = data.filter(function (n) {
      return n.level > level;
    });
    roots.filter(function (n) {
      return !data.some(function (m) {
        return m.level > n.level && m.routePath.indexOf(n.routePath) === 0;
      });
    }).forEach(function (n) {
      return n.isLeaf = true;
    });

    if (others.length > 0) {
      roots.forEach(function (n) {
        n.children = makeTree(others, level + 1, n.routePath);
        n.children.forEach(function (m) {
          return m.parent = n;
        });
      });
    }

    return roots;
  }

  function optionsToString(options) {
    options = options || {};
    var result = JSON.stringify(options);
    result = result.replace(/^{/, '');
    result = result.replace(/}$/, '');
    result = result ? result + "," : '';
    return result;
  }

  function createRouteTemplate(tree) {
    var totalString = '';
    var templateStrs = [];
    tree.forEach(function (node) {
      var templateStr = template.leafNode;
      var replaceTasks = [];

      if (node.level === 1 && node.isLeaf) {
        templateStr = template.singleParentNode;
      } else if (!node.isLeaf) {
        if (node.asEntry) {
          templateStr = template.parentWithEntryNode;
        } else {
          templateStr = template.parentNode;
        }
      } // 通用替换部分


      var metaInfo = node.metaJSON;
      replaceTasks.push({
        key: placeholders.meta,
        value: JSON.stringify(metaInfo)
      });
      var fullPath = "/" + node.routePath.replace(/^\//, '');
      replaceTasks.push({
        key: placeholders.fullPath,
        value: fullPath
      });
      node.fullPath = fullPath;
      var name = metaInfo.name || "/" + node.routePath.replace(/^\//, '');
      replaceTasks.push({
        key: placeholders.name,
        value: name
      });
      node.name = name;
      replaceTasks.push({
        key: placeholders.component,
        value: node.component
      });
      replaceTasks.push({
        key: placeholders.redirect,
        value: optionsToString({
          redirect: metaInfo.redirect ? metaInfo.redirect.split('/').map(function (n) {
            return !n ? n : namingStyle.hyphen(n);
          }).join('/') : undefined
        })
      });
      delete metaInfo.redirect;
      var layoutComponentTemplate = componentTemplates.defaultLayoutComponent;

      if (node.metaJSON.layoutComponent) {
        layoutComponentTemplate = componentTemplates.dynamicImportComponent(node.metaJSON.layoutComponent);
      } else if (node.parent) {
        layoutComponentTemplate = node.parent.component;
      }

      replaceTasks.push({
        key: placeholders.layoutComponent,
        value: layoutComponentTemplate
      });
      replaceTasks.push({
        key: placeholders.customPath,
        value: (metaInfo.path || '').replace(/^\/+/, '') || '/'
      });
      delete metaInfo.path;
      delete node.metaJSON.layoutComponent; // 父节点部分

      if (!node.isLeaf || node.level === 1) {
        var children = '';

        if (!node.isLeaf) {
          children = createRouteTemplate(node.children);
        }

        replaceTasks.push({
          key: placeholders.children,
          value: children
        });
        var routePath = node.routePath.split('/').pop();

        if (node.level === 1) {
          routePath = "/" + node.routePath;
        }

        replaceTasks.push({
          key: placeholders.path,
          value: routePath.replace(/\/+/g, '/')
        });
      } // 子节点部分


      if (node.isLeaf) {
        var _routePath = node.routePath.split('/').pop();

        replaceTasks.push({
          key: placeholders.path,
          value: _routePath
        });
      }

      replaceTasks.forEach(function (task) {
        templateStr = templateStr.replace(new RegExp(task.key, 'g'), task.value);
      });
      templateStrs.push(templateStr);
    });
    totalString = templateStrs.filter(function (n) {
      return !!n;
    }).join(',');
    return totalString;
  }

  function createMetaJSONTree(tree) {
    var metaJSONTree = [];
    tree.forEach(function (node) {
      var newNode = {
        path: "/" + node.routePath.replace(/^\//, ''),
        fullPath: node.fullPath,
        name: node.name,
        meta: node.metaJSON,
        children: undefined
      };
      metaJSONTree.push(newNode);

      if (node.children && node.children.length > 0) {
        newNode.children = newNode.children || [];
        newNode.children = newNode.children.concat(createMetaJSONTree(node.children));
      }
    });
    return metaJSONTree;
  }

  var main = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee(options, hideConsole) {
      var _ref2, cwd, outputRouteFilePath, rootLayoutComponent, newCwd, metaInfos, metaTree, finalStr, metaJSONTreeStr, tempRouteFilePath;

      return _regeneratorRuntime__default['default'].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _ref2 = options || {}, cwd = _ref2.cwd, outputRouteFilePath = _ref2.outputRouteFilePath, rootLayoutComponent = _ref2.rootLayoutComponent;
              defaultLayoutComponent = rootLayoutComponent || defaultLayoutComponent;
              newCwd = replacePathSplit$1(cwd || path.resolve('.')); // 1.获取所有页面元信息

              _context.next = 5;
              return getMetaInfos(newCwd);

            case 5:
              metaInfos = _context.sent;
              // 2.转换成树形
              metaTree = makeTree(metaInfos.list); // 3.生成路由JS字符串

              finalStr = createRouteTemplate(metaTree); // 4.生成metaJSON字符串

              metaJSONTreeStr = JSON.stringify(createMetaJSONTree(metaTree)); // 4.写入文件

              tempRouteFilePath = outputRouteFilePath || path.join(newCwd, 'src', 'router', 'temp.router.js');
              fs__default['default'].removeSync(tempRouteFilePath);
              _context.next = 13;
              return fs__default['default'].outputFile(tempRouteFilePath, jsBeautify.js("\n    export default [" + finalStr + "];\n\n    export const metaJSONTree = " + metaJSONTreeStr + ";\n    ", jsPrettyConfig));

            case 13:
              // 5.完成
              hideConsole === false && console.log('router create complete！', tempRouteFilePath, '\n');

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function main(_x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  var run = throttle__default['default'](main, 500, {
    leading: false,
    trailing: true
  });

  var replacePathSplit = function replacePathSplit(str) {
    return str.replace(/\\/g, '/');
  };

  var vueAutoCreateRoute = (function (options, watchOptions, isWatch) {
    if (isWatch === void 0) {
      isWatch = true;
    }

    var newOptions = _extends({}, options);

    var run$1 = run.bind(null, newOptions, newOptions.hideConsole);

    if (isWatch && "development" !== 'production') {
      // usePolling 开启路径轮询扫描,对文件夹名称修改仍能触发监听 ; interval 轮询间隔毫秒时长
      chokidar__namespace.watch(replacePathSplit(join(newOptions.cwd || '.', '**/meta.json')), _extends({
        usePolling: true,
        interval: 500,
        ignored: '**/node_modules/**/*'
      }, watchOptions)).on('all', run$1);
    } else {
      run$1();
    }
  });

  var timer = 99;
  var sub = {
    lib: 'lib',
    dist: 'rollup'
  };
  var pluginName = 'autoCreateVueRouteWebpackPlugin';
  var first = true;
  var AutoCreateVueRouteWebpackPlugin = /*#__PURE__*/function () {
    function AutoCreateVueRouteWebpackPlugin(options, watchOptions, isWatch) {
      if (isWatch === void 0) {
        isWatch = true;
      }

      this.options = options;
      this.isWatch = isWatch;
      this.watchOptions = watchOptions;
    }

    var _proto = AutoCreateVueRouteWebpackPlugin.prototype;

    _proto.apply = function apply(compiler) {
      var _this = this;

      compiler.hooks.beforeCompile.tap(pluginName, function (compilation) {
        if (first) {
          first = false;
          vueAutoCreateRoute(_this.options, _this.watchOptions, _this.isWatch);
        }
      });
    };

    return AutoCreateVueRouteWebpackPlugin;
  }();

  exports.AutoCreateVueRouteWebpackPlugin = AutoCreateVueRouteWebpackPlugin;
  exports.sub = sub;
  exports.timer = timer;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
